# $Id: composedatestampfromheader.py 3919 2010-08-31 06:51:38Z place $
# $URL: https://svn.non-gnu.uvt.nl/uvt-dev/tags/sources/meresco/bzv-9.4.1/src/composedatestampfromheader.py $
from meresco.core import Observable

class ComposeDateStampFromHeader(Observable):
    def __init__(self, fieldName):
        Observable.__init__(self)
        self._namespaceMap = {'oai_dc':'http://www.openarchives.org/OAI/2.0/'}
        self._fieldName = fieldName

    def add(self, id, partName, lxmlNode):
        datestamps = lxmlNode.xpath('//oai_dc:header/oai_dc:datestamp', self._namespaceMap)

        for datestamp in datestamps:
            text = datestamp.xpath('text()', self._namespaceMap)
            date = text[0][:10]
            yield self.all.addField(name=self._fieldName, value=date)
