# $Id: composejelfrommods.py 3919 2010-08-31 06:51:38Z place $
# $URL: https://svn.non-gnu.uvt.nl/uvt-dev/tags/sources/meresco/bzv-9.4.1/src/composejelfrommods.py $

from meresco.core import Observable
import re

class ComposeJELFromMods(Observable):
    def __init__(self, fieldName ):
        Observable.__init__(self)
        self._namespaceMap = {'mods':'http://www.loc.gov/mods/v3'}
        self._fieldName = fieldName

    def addXml(self, lxmlNode):
        classifications = lxmlNode.xpath('//mods:mods/mods:classification', self._namespaceMap)

        for classification in classifications:
            authority = classification.xpath('@authority', self._namespaceMap)
            text = classification.xpath('text()', self._namespaceMap)

            if len(authority) == 1:
                if str(authority[0]) == 'info:eu-repo/authority/jel' or \
                   str(authority[0]) == 'info:eu-repo/classification/jel':
                    if len(text) == 1:
                        jelcode = text[0].upper()
                        stripped = re.search('^([A-Z]\d{0,2})',jelcode)
                        if stripped:
                            yield self.all.addField(name=self._fieldName, value=stripped.group(0))
